## com.google.javascript.jscomp
Class FieldCleanupPass

    java.lang.Object
      com.google.javascript.jscomp.FieldCleanupPass

All Implemented Interfaces:
  CompilerPass, HotSwapCompilerPass

    public class FieldCleanupPass

extends Object
implements HotSwapCompilerPass

A CleanupPass implementation that will remove all field declarations on JSTypes contributed by the original file.

This pass is expected to clear out declarations contributed to any JSType, even if the constructor declaration is not provided in the file being updated.

Constructor Summary
`FieldCleanupPass(AbstractCompiler compiler)`

Method Summary
`void` | `hotSwapScript(Node scriptRoot, Node originalRoot)` Process the JS with root node root.
`void` | `process(Node externs, Node root)` Process the JS with root node root.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FieldCleanupPass

    public FieldCleanupPass(AbstractCompiler compiler)

Method Detail

### hotSwapScript

    public void hotSwapScript(Node scriptRoot,
                              Node originalRoot)

  Description copied from interface: `HotSwapCompilerPass`
  Process the JS with root node root. This is supposed to be significantly faster compared to corresponding full-compiler passes.

  Specified by:
    `hotSwapScript` in interface `HotSwapCompilerPass`
  Parameters:
    `scriptRoot` - Root node corresponding to the file that is modified, should be of type `Token.SCRIPT`.
    `originalRoot` - Root node corresponding to the original version of the file that is modified. Should be of type `token.SCRIPT`.

### process

    public void process(Node externs,
                        Node root)

  Description copied from interface: `CompilerPass`
  Process the JS with root node root. Can modify the contents of each Node tree

  Specified by:
    `process` in interface `CompilerPass`
  Parameters:
    `externs` - Top of external JS tree
    `root` - Top of JS tree